﻿using System;
using System.Threading.Tasks;
using DotNetCoreRpc.Core;
using DotNetCoreRpc.Core.RpcBuilder;
using Microsoft.Extensions.Logging;
using Newtonsoft.Json;

namespace WebDemo.Filters
{
    public class CacheFilterAttribute: RpcFilterAttribute
    {
        public int CacheTime { get; set; }

        [FromServices]
        private RedisConfigOptions RedisConfig { get; set; }

        [FromServices]
        public ILogger<CacheFilterAttribute> Logger { get; set; }

        public override async Task InvokeAsync(RpcContext context, RpcRequestDelegate next)
        {
            Logger.LogInformation($"CacheFilterAttribute Begin,CacheTime=[{CacheTime}],Class=[{context.TargetType.FullName}],Method=[{context.Method.Name}],Params=[{JsonConvert.SerializeObject(context.Parameters)}]");
            await next(context);
            Logger.LogInformation($"CacheFilterAttribute End,ReturnValue=[{JsonConvert.SerializeObject(context.ReturnValue)}]");
        }
    }
}
